{===================================================================================================

  Comming Library

           .

====================================================================================================

  :

  15.11.2007 [*] RecordExchangeMoving:      .
  23.05.2007 [*] RecordExchangeMoving:   .
  14.04.2006 [*] .
  09.09.2002 [*] RecordExchangeMoving:    .
  09.11.2001 [+] RecordExchangeMoving: , .
             [+]  .
  09.09.1998 [!]  Comming Library.

====================================================================================================
  Copyright 19982007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingDB.pas,v 1.1 2012/02/23 06:37:51 tsk Exp $
===================================================================================================}
unit CommingDB;

interface

uses DB, Variants;

type

  TRecordExchangeMoving = ( rmUp = -1, rmKeep = 0, rmDown = 1 );

  //   ,    .
  function  RecordExchangeMoving( Data: TDataSet; Field: String;
                                  Moving: TRecordExchangeMoving; Descending: Boolean = False;
                                  Delta: Integer = 1 ): Boolean;

  //      Field    SearchValue   .
  procedure SearchNearest( Field1: TField; SearchValue1: Variant );overload;
  procedure SearchNearest( Field1: TField; SearchValue1: Variant; Field2:TField; SearchValue2: Variant); overload;
  procedure SearchNearest( Field1: TField; SearchValue1: Variant; Field2:TField; SearchValue2: Variant; Field3:TField; SearchValue3: Variant); overload;

implementation
//==================================================================================================
function RecordExchangeMoving( Data: TDataSet; Field: String;
                               Moving: TRecordExchangeMoving; Descending: Boolean;
                               Delta: Integer ): Boolean;
  var New, Old: Integer;
      Rec: TBookmark;
begin
  Result := False;
  if Moving = rmKeep then Exit;
  with Data do begin
    Rec := GetBookmark;
    Old := FieldByName(Field).AsInteger;
    if Old < 0 then Old := 0;
    case Moving of
      rmDown:
        begin
          Next;
          if Eof then Exit;
        end;
      rmUp:
        begin
          Prior;
          if Bof then Exit;
        end;
    end;
    New := FieldByName(Field).AsInteger;
    if ( Old = New ) then
      if Descending
        then New := New - ( Ord( Moving ) * Delta )
        else New := New + ( Ord( Moving ) * Delta );
    if New < 0 then New := Data.RecordCount + 1;
    Edit;
    FieldByName(Field).AsInteger := Old ;
    Post;
    GotoBookmark( Rec );
    Edit;
    FieldByName(Field).AsInteger := New;
    Post;
  end;
  Result := True;
end;
//==================================================================================================
procedure SearchNearest(Field1: TField; SearchValue1: Variant);
begin
  with  Field1.DataSet do begin
    DisableControls;
    First;
    while ( Field1.IsNull or ( Field1.Value < SearchValue1 )) and (not Eof ) do Next;
    EnableControls;
  end;
end;
//==================================================================================================
procedure SearchNearest(Field1: TField; SearchValue1: Variant; Field2:TField; SearchValue2: Variant);
begin
 with  Field1.DataSet do begin
    DisableControls;
    First;
    while ( ( Field1.IsNull or ( Field1.Value < SearchValue1 ))
           or ( Field2.IsNull or ( Field2.Value < SearchValue2 ))) and ( not Eof ) do Next;
    EnableControls;
 end;
end;
//==================================================================================================
procedure SearchNearest( Field1:TField; SearchValue1:Variant;
                         Field2:TField; SearchValue2:Variant;
                         Field3:TField; SearchValue3:Variant );
begin
  with Field1.DataSet do begin
    DisableControls;
    First;
    while ( ( Field1.IsNull or ( Field1.Value < SearchValue1 ))
           or ( Field2.IsNull or ( Field2.Value < SearchValue2 ))
           or ( Field3.IsNull or ( Field3.Value < SearchValue3 ))) and ( not Eof ) do Next;
    EnableControls;
  end;
end;
//==================================================================================================
end.
