{=======================================================================================================================

  Comming Library

          .

========================================================================================================================

  :

  24.03.2012 [-]  DateToSQL  CommingADO.
  11.02.2012 [*]  FormatSettings.
             [*] .
  09.02.2012 [!]    Delphi XE2.
  20.03.2007 [*] DateToSQL:    MS SQL.
  27.03.2002 [*] FirstDayYear:   .
  06.02.2002 [+] FirstDayMonthPrior:    .
  15.12.2001 [+] LastDayMonth:   .
  03.09.2001 [+] FourDigitYear:    4   .
  18.04.2001 [+]       .
             [+]    .
  23.10.2000 [*]     FirstDayMonth.
  21.08.2000 [+] iYear  sYear.
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingDateTime.pas,v 1.2 2012/10/25 11:00:51 tsk Exp $
=======================================================================================================================}
unit CommingDateTime;

interface

uses SysUtils, CommingOther;

  function    cDate( DateValue: TDateTime; FullYear: Boolean = True ): String;
  function    cMonth( i: Integer ): String;
  function    cMonths( i: Integer ): String;
  function    cMonthYear( t: TDateTime ): String;
  function    cYear( t: TDateTime ): String;
  function    iYear( Dat: TDateTime = -1 ): Integer;
  function    sYear( Date: TDateTime ): String;
  function    ShortYear( Dat: TDateTime): String;
  function    ShortYearMonth(Dat: TDateTime): String;
  function    DMYToDate( sDate: String ): TDateTime;

  function    DaysPerMonth( iYear, iMonth: Integer): Integer; overload;
  function    DaysPerMonth( dDate: TDateTime ): Integer; overload;

  function    IsCurrentMonth( dc1, dc2: TDateTime ): Boolean;
  function    IsCurrentYear( dc1, dc2: TDateTime ): Boolean;
              {   . - -  . }
  function    FirstDayMonth( Date: TDateTime = -1 ): TDateTime;
              {   . - -  . }
  function    LastDayMonth( Date: TDateTime = -1 ): TDateTime;

  function    FirstDayMonthPrior( Date: TDateTime = -1 ): TDateTime;

  function    FirstNextMonth( dt: TDateTime): TDateTime;
  function    LastDayYear( dt: TDateTime ): TDateTime;
              {   . - -  . }
  function    FirstDayYear( Date: TDateTime = - 1 ): TDateTime;

  function    DaysBetween( DateBeg, DateEnd: TDateTime): Integer;

  function    DateTimeToFileName( xDT: TDateTime ): String;
  function    StrToDateFmt( DateFormat, Str: String ): TDateTime;
  function    StrToDateFmtDef( DateFormat, Str: String; Default: TDateTime ): TDateTime;

  function    FourDigitYear: Boolean;

  function    IncDate( ADate: TDateTime; Days, Months, Years: Integer ): TDateTime;
  function    IncDay( ADate: TDateTime; Delta: Integer ): TDateTime;
  function    IncMonth( ADate: TDateTime; Delta: Integer ): TDateTime;
  function    IncYear( ADate: TDateTime; Delta: Integer ): TDateTime;

  const
    CenturyOffset: Byte = 60;
    NullDate: TDateTime = 0;

implementation
//======================================================================================================================
function cMonths( i: Integer ): String;
  const sMonth: array[0..11] of String = ( '',  '',  '',
                                           '',  '',      '',
                                           '',    '',  '',
                                           '', '',   '' );
begin
  Result := ' ' + sMonth[ i - 1 ] + ' ';
end;
//======================================================================================================================
function cMonth( i: Integer ): String;
begin
  case i of
    1: Result := '';
    2: Result := '';
    3: Result := '';
    4: Result := '';
    5: Result := '';
    6: Result := '';
    7: Result := '';
    8: Result := '';
    9: Result := '';
    10: Result := '';
    11: Result := '';
    12: Result := '';
  end;
end;
//======================================================================================================================
function cDate( DateValue: TDateTime; FullYear: Boolean = True ): String;
  var d, m, y: Word;
begin
  DecodeDate( DateValue, y, m, d );
  Result := IntToStr(round( d )) + cMonths( round( m ) ) + IntToStr(round( y )) +
            iif( FullYear, ' ', ' .' );
end;
//======================================================================================================================
function cMonthYear( t: TDateTime): String;
  var d, m, y: Word;
begin
  DecodeDate( t, y, m, d );
  Result := cMonth( round( m ) ) + ' ' + IntToStr(round( y )) + ' '
end;
//======================================================================================================================
function cYear( t: TDateTime ): String;
  var d, m, y: Word;
begin
  DecodeDate( t, y, m, d );
  Result := IntToStr(round( y )) + ' '
end;
//======================================================================================================================
function iYear( Dat: TDateTime ): Integer;
  var d, m, y: Word;
begin
  if Dat < 0 then Dat := Now;
  DecodeDate( Dat, y, m, d );
  Result := y;
end;
//======================================================================================================================
function   sYear( Date: TDateTime ): String;
begin
  Result := IntToStr( iYear( Date ));
end;
//======================================================================================================================
function ShortYear( Dat: TDateTime ): String;
//  var d, m, y: Word;
begin
//  DecodeDate( Dat, y, m, d );
  Result := FormatDateTime( 'yy', Dat );  // Copy( IntToStr(round( y )), 3, 2);
end;
//======================================================================================================================
function ShortYearMonth(Dat: TDateTime): String;
  var d, m, y: Word;
begin
  DecodeDate(Dat, y, m, d);
  Result := Copy(IntToStr(Round(y)), 3, 2) +
     iif(Round(m) < 10, '0', '') + IntToStr(Round(m));
end;
//======================================================================================================================
function FirstNextMonth( dt: TDateTime): TDateTime;
  var d, m, y: Word;
begin
  DecodeDate( dt, y, m, d );
  IncAMonth( y, m, d );
  Result := EncodeDate( y, m, 1 );
end;
//======================================================================================================================
function FirstDayMonth( Date: TDateTime ): TDateTime;
  var d, m, y: Word;
begin
  if Date <= 0 then Date := Now;
  DecodeDate( Date, y, m, d );
  Result := EncodeDate( y, m, 1 );
end;
//======================================================================================================================
function FirstDayMonthPrior( Date: TDateTime ): TDateTime;
  var d, m, y: Word;
begin
  if Date <= 0 then Date := Now;
  DecodeDate( Date, y, m, d );
  IncAMonth( y, m, d, -1 );
  Result := EncodeDate( y, m, 1 );
end;
//======================================================================================================================
function LastDayMonth( Date: TDateTime ): TDateTime;
  var d, m, y: Word;
begin
  if Date <= 0 then Date := Now;
  DecodeDate( Date, y, m, d );
  Result := EncodeDate( y, m, DaysPerMonth( y, m ));
end;
//======================================================================================================================
function IsCurrentMonth( dc1, dc2: TDateTime ): Boolean;
  var d1, d2, m1, m2, y1, y2: Word;
begin
  DecodeDate( dc1, y1, m1, d1 );
  DecodeDate( dc2, y2, m2, d2 );
  Result := ( ( y1 = y2 ) and ( m1 = m2 ));
end;
//======================================================================================================================
function IsCurrentYear( dc1, dc2: TDateTime ): Boolean;
  var d1, d2, m1, m2, y1, y2: Word;
begin
  DecodeDate( dc1, y1, m1, d1 );
  DecodeDate( dc2, y2, m2, d2 );
  Result := ( y1 = y2 );
end;
//======================================================================================================================
function LastDayYear( dt: TDateTime ): TDateTime;
  var d, m, y: Word;
begin
  DecodeDate( dt, y, m, d );
  Result := EncodeDate( y, 12, 31 );
end;
//======================================================================================================================
function  FirstDayYear( Date: TDateTime ): TDateTime;
  var d, m, y: Word;
begin
  if Date < 0 then Date := Now;
  DecodeDate( Date, y, m, d );
  Result := EncodeDate( y, 1, 1 );
end;
//======================================================================================================================
function DaysPerMonth( iYear, iMonth: Integer): Integer;
  const DaysInMonth: array[1..12] of Integer = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
begin
  Result := DaysInMonth[ iMonth ];
  if ( iMonth = 2 ) and IsLeapYear( iYear ) then Inc( Result ); //  
end;
//======================================================================================================================
function DaysPerMonth( dDate: TDateTime ): Integer;
  var d, m, y: Word;
begin
  DecodeDate( dDate, y, m, d );
  Result := DaysPerMonth( y, m );
end;
//======================================================================================================================
function DateTimeToFileName( xDT: TDateTime ): String;
begin
  Result := DateTimeToStr( xDT );
  while Pos( '.', Result ) > 0  do Result[ Pos( '.', Result )] := '-';
  while Pos( ':', Result ) > 0  do Result[ Pos( ':', Result )] := '-';
end;
//======================================================================================================================
function DMYToDate( sDate: String ): TDateTime;
  var d, m, y: Word;
begin
  d := StrToInt( Copy( sDate, 1, 2 ));
  m := StrToInt( Copy( sDate, 3, 2 ));
  y := StrToInt( Copy( sDate, 5, 2 )) + 1900;
  Result := EncodeDate( y, m, d );
end;
//======================================================================================================================
function DaysBetween( DateBeg, DateEnd: TDateTime): Integer;
begin
  Result := Abs( Trunc( DateBeg ) - Trunc( DateEnd ) + 1 );
end;
//======================================================================================================================
function FourDigitYear: Boolean;
begin
  Result := Pos( 'YYYY', AnsiUpperCase( FormatSettings.ShortDateFormat )) > 0;
end;
//======================================================================================================================
function IncDate( ADate: TDateTime; Days, Months, Years: Integer ): TDateTime;
begin
  Result := ADate + EncodeDate(Years, Months, Days);
end;
//======================================================================================================================
function IncDay( ADate: TDateTime; Delta: Integer ): TDateTime;
begin
  Result := ADate + Delta;
end;
//======================================================================================================================
function IncMonth(ADate: TDateTime; Delta: Integer): TDateTime;
begin
  Result := ADate + EncodeDate( 0, Delta, 0 );
end;
//======================================================================================================================
function IncYear(ADate: TDateTime; Delta: Integer): TDateTime;
begin
  Result := ADate + EncodeDate( Delta, 0, 0 );
end;
//======================================================================================================================
function StrToDateFmt( DateFormat, Str: String ): TDateTime;
  var Old: String;
begin
  Old := FormatSettings.ShortDateFormat;
  try
    FormatSettings.ShortDateFormat := DateFormat;
    Result := StrToDate( Str );
  finally
    FormatSettings.ShortDateFormat := Old;
  end;
end;
//======================================================================================================================
function StrToDateFmtDef( DateFormat, Str: String; Default: TDateTime ): TDateTime;
  var Old: String;
begin
  Old := FormatSettings.ShortDateFormat;
  FormatSettings.ShortDateFormat := DateFormat;
  Result := StrToDateDef( Str, Default );
  FormatSettings.ShortDateFormat := Old;
end;
//======================================================================================================================
end.
