{=======================================================================================================================

  Comming Library.

    Shell API.   .

========================================================================================================================

  :

  09.02.2012 [!]    Delphi XE2.
  12.02.2009 [+]  .
  15.02.2003 [*] .
  17.11.2003 [*]  .
             [!]    Comming.  .
  09.11.2002 [-]      .
             [-]  PopMenu.
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingShellFoldersBrowse.pas,v 1.1 2012/03/05 08:49:18 tsk Exp $
=======================================================================================================================}
{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
     TsohoBrowseFolder,       Browse .
}
unit CommingShellFoldersBrowse;

//{$I SOHOLIB.INC}

interface

uses Windows, Messages, Classes, Forms, Dialogs, SysUtils, ActiveX, Shlobj, Controls,
     Graphics, ShellAPI, CommingFile;

type

  TsohoBrowseViewFlag = (
     bvBrowseForComputer,
     bvBrowseForPrinter,
     bvDontGoBelowDomain,
     bvFileSysAncestors,
     bvFileSysDirsOnly,
     bvStatusText,
     bvEditBox
  );
  {     Browse }

  TsohoBrowseViewFlags = set of TsohoBrowseViewFlag;
  {     Browse.    TsohoBrowseViewFlag }

  TsohoBrowseFolders = (
     bfControlPanel,
     bfDesktop,
     bfDesktopExpanded,
     bfDesktopDirectory,
     bfFavorites,
     bfFonts,
     bfMyComputer,
     bfNetwork,
     bfNetworkNeighborhood,
     bfPersonal,
     bfPrograms,
     bfPrinters,
     bfRecent,
     bfRecycleBin,
     bfSendto,
     bfStartMenu,
     bfStartup,
     bfTemplates);
  {   ,     }

type

  TsohoChangedEvent  = procedure (Sender: TObject; const ItemIDList: PItemIDList;
                       const DirName: string) of object;
  {    OnChange }

  TcoShellFolderBrowse = class(TComponent)
  {     Browse. }
  private
    FDialogHandle: HWND;
    FTitle: string;
    FParentHandle: HWND;
    FDisplayName: string;
    FImageIndex: Integer;
    FDirectory: string;
    FSelectedDirectory: string;
    FFlags: TsohoBrowseViewFlags;
    FPathInStatus: boolean;
    FRootFolder: TsohoBrowseFolders;
    FOnInitialized: TNotifyEvent;
    FOnChange: TsohoChangedEvent;
  protected
    procedure SetStatusText(StatusText: string);
    procedure SetOKEnabled (Value: boolean);
    procedure DoInitialized; virtual;
    procedure DoChange(const ItemIDList: PItemIDList; const DirName: string); virtual;
    procedure SetSelectionPath(const Path: string);
  public
    constructor Create(AOwner: TComponent); override;
    function Execute: boolean;
    procedure SetSelectionPIDL(const ItemIDList: PItemIDList);
    property DisplayName: string read FDisplayName;
    property ImageIndex: Integer read FImageIndex;
    property ParentHandle: HWND read FParentHandle write FParentHandle; // Added by Atoh Tanner
    property DialogHandle: HWND read FDialogHandle write FDialogHandle;
    property SelectedDirectory: string read FSelectedDirectory write FSelectedDirectory;
    property OkEnabled : boolean write SetOKEnabled;
  published
    property Directory: string read FDirectory write FDirectory;
    {       }
    property Title: string read FTitle write FTitle;
    {   }
    property ViewFlags: TsohoBrowseViewFlags read FFlags write FFlags default [bvFileSysDirsOnly, bvStatusText];
    {   }
    property PathInStatus: boolean read FPathInStatus write FPathInStatus default true;
    {        }
    property RootFolder: TsohoBrowseFolders read FRootFolder write FRootFolder default bfDesktopExpanded;
    {   }
    property OnInitialized: TNotifyEvent read FOnInitialized write FOnInitialized;
    {       }
    property OnChange: TsohoChangedEvent read FOnChange write FOnChange;
    {        }
  end;

procedure BrowserCallbackProc(HWindow: HWND; uMsg: Integer; lParameter: LPARAM; lpBrowseFolder: LPARAM); stdcall;

//function GetSpecialFolderLocation(Value: TsohoBrowseFolders): string;
{     ""  - " ", ""  .. }

//procedure Register;

implementation

{uses CommingSohoUnit{SoAppUtils;}
//======================================================================================================================
{  }
//======================================================================================================================
procedure Register;
begin
  RegisterComponents( 'Comming', [TcoShellFolderBrowse] );
end;
//======================================================================================================================
const
  NUMBER_OF_BROWSE_VIEW_FLAGS = 7;
  NOT_SUPPORTED = -1;

  BROWSE_FLAGS: array[TsohoBrowseViewFlag] of DWORD = (
     BIF_BROWSEFORCOMPUTER,
     BIF_BROWSEFORPRINTER,
     BIF_DONTGOBELOWDOMAIN,
     BIF_RETURNFSANCESTORS,
     BIF_RETURNONLYFSDIRS,
     BIF_STATUSTEXT,
     BIF_EDITBOX
  );

  SH_FOLDERS: array[TsohoBrowseFolders] of LongInt = (
     CSIDL_CONTROLS,
     CSIDL_DESKTOP,
     NOT_SUPPORTED,
     CSIDL_DESKTOPDIRECTORY,
     CSIDL_FAVORITES,
     CSIDL_FONTS,
     CSIDL_DRIVES,
     CSIDL_NETWORK,
     CSIDL_NETHOOD,
     CSIDL_PERSONAL,
     CSIDL_PROGRAMS,
     CSIDL_PRINTERS,
     CSIDL_RECENT,
     CSIDL_BITBUCKET,
     CSIDL_SENDTO,
     CSIDL_STARTMENU,
     CSIDL_STARTUP,
     CSIDL_TEMPLATES
   );

{function GetSpecialFolderLocation(Value: TsohoBrowseFolders): string;
var PIDL: PItemIDList;
    Path: lpstr;
begin
  Path := StrAlloc(MAX_PATH);
  SHGetSpecialFolderLocation(0, Integer(SH_FOLDERS[Value]), PIDL);
  Result := '';
  if SHGetPathFromIDList(PIDL, Path) then Result := StrPas(Path);
  StrDispose(Path);
end;}

function ParseText(const Text, Separator: string; var Tokens: TStringList): Integer;
var Index: LongInt;
    CurrentString: string;
    CurrentToken : string;
begin
  Result := 0;
  CurrentString := Text;
  Tokens.Clear;
  repeat
    Index := Pos(Separator, CurrentString);
    if index = 0 then begin
      CurrentToken := CurrentString;
      exit;
    end
    else begin
      CurrentToken := Copy(CurrentString, 1, Index - 1);
      CurrentString := Copy(CurrentString, Index + 1, Length(CurrentString) - Index);
    end;

    Tokens.Add(CurrentToken);
    Inc(Result);
  until 0 <> 0;
end;

function ShortString(const Path, SEPARATOR, Replacement: string; MaxLength: LongInt): string;
var Tokens: TStringList;

  function BuildPath: string;
  var Index: LongInt;
  begin
    for Index := 0 to pred(Tokens.Count) do
      if Index = 0 then Result := Tokens[Index]
      else Result := Result + Separator + Tokens[Index];
  end;

begin
  try
    Tokens := TStringList.Create;

    Result := Path;
    if LongInt(StrLen(PChar(Result))) <= MaxLength then exit;

    if ParseText(Result, Separator, Tokens) < 3 then exit
    else begin
      Tokens[1] := Replacement;
      Result := BuildPath;
    end;

    while (LongInt(StrLen(PChar(Result))) > MaxLength) and
          (Tokens.Count > 3) do begin
      Tokens.Delete(2);
      Result := BuildPath;
    end;
  finally
    Tokens.Free;
  end;
end;

procedure CenterWindow(HWindow: HWND);
var Rect, FWRect: TRect;
    ForegroundWindow: HWND;
begin
  ForegroundWindow := GetForegroundWindow;
  GetWindowRect(HWindow, Rect);
  GetWindowRect(ForegroundWindow, FWRect);
  SetWindowPos(HWindow, 0,
    (FWRect.Left + (FWRect.Right - FWRect.Left) div 2) - (Rect.Right - Rect.Left) div 2,
    FWRect.Top + ((FWRect.Bottom - FWRect.Top) div 4),
    0, 0, SWP_NOACTIVATE or SWP_NOSIZE or SWP_NOZORDER);
end;

procedure GetIDListFromPath(Path: string; var ItemIDList: PItemIDList);
var ShellFolderInterface: IShellFolder;
    CharsParsed, Attributes: ULONG;
begin
  if SHGetDesktopFolder(ShellFolderInterface) = NOERROR then
    try
      if DirectoryExists(Path) then
        ShellFolderInterface.ParseDisplayName(0, nil, StringToOleStr(Path),
          CharsParsed, ItemIDList, Attributes);
    finally
      ShellFolderInterface._Release;
    end;
end;

procedure BrowserCallbackProc(HWindow: HWND; uMsg: Integer; lParameter: LPARAM; lpBrowseFolder: LPARAM);
  var Browser: TcoShellFolderBrowse;
      Path: string;
      TempPath : array[0..MAX_PATH] of Char;
begin
  Browser := TcoShellFolderBrowse(lpBrowseFolder);

  case uMsg of
    BFFM_INITIALIZED: begin
      Browser.DialogHandle := HWindow;
      CenterWindow(HWindow);
      SetWindowLong(HWindow, GWL_USERDATA, lpBrowseFolder);
      if DirectoryExists(Browser.Directory) then
        Browser.SetSelectionPath(Browser.Directory);
      Browser.DoInitialized;
    end;

    BFFM_SELCHANGED: begin
      SHGetPathFromIDList(PItemIDList(lParameter), TempPath);
      Browser.FSelectedDirectory := StrPas(TempPath);
      if Browser.PathInStatus then begin
        SetLength(Path, MAX_PATH);
        Path := ShortString(Browser.FSelectedDirectory, '\', '...', MAX_PATH);
        SendMessage(HWindow, BFFM_SETSTATUSTEXT, 0, Longint(PChar(Path)));
      end;

      Browser.OKEnabled := SHGetPathFromIDList(PItemIDList(lParameter), TempPath);;
      Browser.DoChange(PItemIDList(lParameter), Browser.FSelectedDirectory);
    end;
  end;
end;

{ TsohoBrowseFolder }
procedure TcoShellFolderBrowse.DoInitialized;
begin
  if Assigned(FOnInitialized) then FOnInitialized(Self);
end;

procedure TcoShellFolderBrowse.DoChange(const ItemIDList: PItemIDList;
   const DirName: string);
begin
  if Assigned(FOnChange) then FOnChange(Self, ItemIDList, DirName);
end;

constructor TcoShellFolderBrowse.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  SetLength(FDisplayName, MAX_PATH);
  SetLength(FDirectory, MAX_PATH);
  FParentHandle := 0;
  FRootFolder := bfDesktopExpanded;
  FFlags := [bvFileSysDirsOnly, bvStatusText];
  FDirectory := '';
  FSelectedDirectory := '';
  FPathInStatus := true;
end;

procedure TcoShellFolderBrowse.SetStatusText(StatusText: string);
begin
  SendMessage(DialogHandle, BFFM_SETSTATUSTEXT, 0, Longint(PChar(StatusText)));
end;

procedure TcoShellFolderBrowse.SetSelectionPIDL(const ItemIDList: PItemIDList);
begin
  SendMessage(DialogHandle, BFFM_SETSELECTION, Ord(False), Longint(ItemIDList));
end;

procedure TcoShellFolderBrowse.SetSelectionPath(const Path: string);
var Tmp: string;
begin
  Tmp := Path;
  if Tmp[length(Tmp)] = '\' then Delete(Tmp, length(Tmp), 1);
  SendMessage(DialogHandle, BFFM_SETSELECTION, Ord(True), Longint(PChar(Tmp)));
end;

procedure TcoShellFolderBrowse.SetOkEnabled(Value: boolean);
begin
  SendMessage(DialogHandle, BFFM_ENABLEOK, 0, Ord(Value));
end;

function TcoShellFolderBrowse.Execute: boolean;
var BrowseInfo: TBrowseInfo;
    ItemIDList: PItemIDList;
    Index: LongInt;
    TempPath  : array[0..MAX_PATH] of Char;
begin
  ItemIDList := nil;
  try
    if IsWindow(FParentHandle) then BrowseInfo.hwndOwner := FParentHandle
    else
      if (Owner is TWinControl) then
        BrowseInfo.hwndOwner := TWinControl(Owner).Handle
      else
        BrowseInfo.hwndOwner := Application.MainForm.Handle;

    if FRootFolder = bfDesktopExpanded then BrowseInfo.pidlRoot := nil
    else SHGetSpecialFolderLocation(Application.Handle,
         SH_FOLDERS[FRootFolder], BrowseInfo.pidlRoot);

    BrowseInfo.pszDisplayName := PChar(FDisplayName);
    BrowseInfo.lpszTitle := PChar(FTitle);

    BrowseInfo.ulFlags := 0;
//    BrowseInfo.ulFlags := BIF_EDITBOX;
    for Index := 0 to pred(NUMBER_OF_BROWSE_VIEW_FLAGS) do
      if TsohoBrowseViewFlag(Index) in FFlags then
        BrowseInfo.ulFlags := BrowseInfo.ulFlags or
                              BROWSE_FLAGS[TsohoBrowseViewFlag(Index)];

    BrowseInfo.lpfn := @BrowserCallbackProc;
    BrowseInfo.LPARAM := Longint(Self);
    BrowseInfo.iImage := 0;

    ItemIDList := SHBrowseForFolder(BrowseInfo);
    Result := ItemIDList <> nil;
    if Result then begin
      SHGetPathFromIDList(ItemIDList, TempPath);
      FDirectory := NormalDir(StrPas(TempPath));
      FSelectedDirectory := FDirectory;
      FImageIndex := BrowseInfo.iImage;
    end;
  finally
    CoTaskMemFree(ItemIDList);
    CoTaskMemFree(BrowseInfo.pidlRoot);
  end;
end;
//======================================================================================================================
end.

